3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
7 octet
='[0-9a-f][0-9a-f]'
8 octet4
="$octet$octet$octet$octet"
9 octet19
="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20
="$octet4$octet4$octet4$octet4$octet4"
11 nullsha
="0000000000000000000000000000000000000000"
15 # set a sane umask that never excludes any user or group permissions
16 umask $
(printf '0%03o' $
(( $
(umask) & ~
0770 )) )
19 # Compare $1 to $2 each of which must match \d+(\.\d+)*
20 # An empty string ('') for $1 or $2 is treated like 0
25 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
29 [ -n "$_a" -o -n "$_b" ]
31 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
34 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
40 set -- "${_a2#.}" "${_b2#.}"
45 get_girocco_config_pm_var_list
() {
46 # Export all the variables from Girocco::Config to suitable var= lines
47 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
48 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
49 __girocco_conf
="$GIROCCO_CONF"
50 [ -n "$__girocco_conf" ] || __girocco_conf
="Girocco::Config"
51 [ -z "$basedir" ] || __girocco_extrainc
="-I$basedir"
52 perl
-I@basedir@
$__girocco_extrainc -M$__girocco_conf -le \
53 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
54 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
55 $val =~ s/([\\"\$\`])/\\$1/gos;
56 $val =~ s/(?:\r\n|\r|\n)$//os;
57 print "cfg_$_=\"$val\"";
58 print "defined_cfg_$_=",
59 (defined(${$Girocco::Config::{$_}})?"1":"");
63 get_girocco_config_var_list
() (
64 # Same as get_girocco_config_pm_var_list except that
65 # the following variables (all starting with var_) are added:
66 # var_group cfg_owning_group if defined otherwise `id -gn`
67 # var_git_ver The version number part from `git version`
68 # var_git_exec_path The result of $cfg_git_bin --exec-dir
69 # var_perl_bin Full path to the perl interpreter to use
70 # var_have_git_171 Set to 1 if git version >= 1.7.1 otherwise ''
71 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
72 # var_have_git_173 Set to 1 if git version >= 1.7.3 otherwise ''
73 # var_have_git_1710 Set to 1 if git version >= 1.7.10 otherwise ''
74 # var_have_git_185 Set to 1 if git version >= 1.8.5 otherwise ''
75 # var_window_memory Value to use for repack --window-memory=
76 # var_big_file_threshold Value to use for core.bigFileThreshold
77 # var_redelta_threshold Recompute deltas if no more than this many objs
78 # var_log_window_size Value to use for git-svn --log-window-size=
79 # var_utf8_locale Value to use for a UTF-8 locale if available
80 # var_xargs_r A "-r" if xargs needs it to behave correctly
81 # var_du_exclude Option to exclude PATTERN from du if available
82 # var_du_follow Option to follow command line sym links if available
83 _cfg_vars
="$(get_girocco_config_pm_var_list)"
85 printf '%s\n' "$_cfg_vars"
86 printf 'var_group=%s\n' "${cfg_owning_group:-$(id -gn)}"
87 _gver
="$("$cfg_git_bin" version 2>/dev/null | \
88 LC_ALL=C sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
89 printf 'var_git_ver=%s\n' "$_gver"
90 printf 'var_git_exec_path="%s"\n' "$("$cfg_git_bin" --exec-path 2>/dev/null)"
91 printf 'var_perl_bin="%s"\n' "${cfg_perl_bin:-$(unset -f perl; command -v perl)}"
92 printf 'var_have_git_171=%s\n' "$([ $(vcmp "$_gver" 1.7.1) -ge 0 ] && echo 1)"
93 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
94 printf 'var_have_git_173=%s\n' "$([ $(vcmp "$_gver" 1.7.3) -ge 0 ] && echo 1)"
95 printf 'var_have_git_1710=%s\n' "$([ $(vcmp "$_gver" 1.7.10) -ge 0 ] && echo 1)"
96 printf 'var_have_git_185=%s\n' "$([ $(vcmp "$_gver" 1.8.5) -ge 0 ] && echo 1)"
97 __girocco_conf
="$GIROCCO_CONF"
98 [ -n "$__girocco_conf" ] || __girocco_conf
="Girocco::Config"
99 [ -z "$basedir" ] || __girocco_extrainc
="-I$basedir"
100 printf "var_window_memory=%s\n" \
101 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
102 -MGirocco::Util -e 'print calc_windowmemory')"
103 printf "var_big_file_threshold=%s\n" \
104 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
105 -MGirocco::Util -e 'print calc_bigfilethreshold')"
106 printf "var_redelta_threshold=%s\n" \
107 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
108 -MGirocco::Util -e 'print calc_redeltathreshold')"
109 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
110 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
111 _guess_locale
="$(locale -a | LC_ALL=C grep -viE '^(posix|c)(\..*)?$' | \
112 LC_ALL=C grep -iE '\.utf-?8$' | LC_ALL=C sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
113 LC_ALL=C sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
114 head -n 1 | LC_ALL=C cut -d ' ' -f 2)"
115 [ -z "$_guess_locale" ] ||
printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
116 # On some broken platforms running xargs without -r and empty input runs the command
117 printf 'var_xargs_r=%s\n' "$(: | command xargs echo -r)"
118 # The disk usage report produces better numbers if du has an exclude option
119 _x0
="$(basename "$0")"
121 for _duopt
in --exclude -I; do
122 if _test
="$(du $_duopt 's?lib.s*' $_duopt "$_x0" "$0" 2>/dev/null)" && [ -z "$_test" ]; then
123 printf 'var_du_exclude=%s\n' "$_duopt"
127 if _test
="$(du -H "$0" 2>/dev/null)" && [ -n "$_test" ]; then
128 printf 'var_du_follow=%s\n' "-H"
133 # If basedir has been replaced, and shlib_vars.sh exists, get the config
134 # definitions from it rather than running Perl.
135 if [ "@basedir@" = '@'basedir
'@' ] ||
! [ -r "@basedir@/shlib_vars.sh" ]; then
136 # Import all the variables from Girocco::Config to the local environment,
137 eval "$(get_girocco_config_var_list)"
139 # Import the variables from shlib_vars.sh which avoids needlessly
140 # running another copy of Perl
141 .
"@basedir@/shlib_vars.sh"
144 # git_add_config "some.var=value"
145 # every ' in value must be replaced with the 4-character sequence '\'' before
146 # calling this function or Git will barf. Will not be effective unless running
147 # Git version 1.7.3 or later.
149 GIT_CONFIG_PARAMETERS
="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }'$1'"
150 export GIT_CONFIG_PARAMETERS
153 # Make sure we have a reproducible environment by using a controlled HOME dir
154 XDG_CONFIG_HOME
="$cfg_chroot/var/empty"
155 HOME
="$cfg_chroot/etc/girocco"
157 GIT_CONFIG_NOSYSTEM
=1
159 GIT_NO_REPLACE_OBJECTS
=1
160 GIT_TERMINAL_PROMPT
=0
161 GIT_ASKPASS
="$cfg_basedir/bin/git-askpass-password"
162 export XDG_CONFIG_HOME
165 export GIT_CONFIG_NOSYSTEM
166 export GIT_ATTR_NOSYSTEM
167 export GIT_NO_REPLACE_OBJECTS
168 export GIT_TERMINAL_PROMPT
171 unset GIT_HTTP_USER_AGENT
172 if [ -n "$defined_cfg_git_client_ua" ]; then
173 GIT_USER_AGENT
="$cfg_git_client_ua"
174 export GIT_USER_AGENT
175 GIT_HTTP_USER_AGENT
="$cfg_git_client_ua"
176 export GIT_HTTP_USER_AGENT
178 unset GIT_CONFIG_PARAMETERS
179 git_add_config
"core.ignoreCase=false"
180 [ -z "$var_big_file_threshold" ] ||
181 git_add_config
"core.bigFileThreshold=$var_big_file_threshold"
183 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
184 # and nc_openbsd to the desired executables because when using
185 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
186 # different and unexpected ways:
187 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
188 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
189 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
190 # None of these are good. We want a temporary "export ENV_VAR=xxx"
191 # setting only while running func which none of the /bin/sh's do.
193 # Instead we'd like to use an alias that provides the desired behavior without
194 # any of the bad (a), (b) or (c) effects.
196 # However, unfortunately, some of the crazy /bin/sh implementations do not
197 # recognize alias expansions when preceded by variable assignments!
199 # So we are left with git() {} and nc_openbsd() {} functions and in the
200 # case of git() {} we can compensate for (b) and (c) failing to export
201 # but not (a) and (b) persisting the values so the caller will simply
202 # have to beware and explicitly unset any variables that should not persist
203 # beyond the function call itself.
206 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
207 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
208 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
209 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
210 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
211 exec "$cfg_git_bin" "$@"
214 # see comments for git() -- callers must explicitly export all variables
215 # intended for the perl interpreter before using this function
216 perl
() { command "${var_perl_bin:-perl}" "$@"; }
218 nc_openbsd
() { "$cfg_nc_openbsd_bin" "$@"; }
220 list_packs
() { command "$cfg_basedir/bin/list_packs" "$@"; }
222 strftime
() { command "$cfg_basedir/bin/strftime" "$@"; }
224 # Some platforms' broken xargs runs the command always at least once even if
225 # there's no input unless given a special option. Automatically supply the
226 # option on those platforms by providing an xargs function.
227 xargs() { command xargs $var_xargs_r "$@"; }
231 for _addr
in "$@"; do
232 [ -z "$_list" ] || _list
="$_list, "
239 _mailer
="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
240 if [ -n "$cfg_sender" ]; then
241 "$_mailer" -i -f "$cfg_sender" "$@"
249 if [ "$1" = "-s" ]; then
255 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
256 echo "To: $(_addrlist "$@
")"
257 [ -z "$_subject" ] ||
echo "Subject: $_subject"
258 echo "MIME-Version: 1.0"
259 echo "Content-Type: text/plain; charset=utf-8"
260 echo "Content-Transfer-Encoding: 8bit"
261 [ -n "$cfg_suppress_x_girocco" ] ||
echo "X-Girocco: $cfg_gitweburl"
262 echo "Auto-Submitted: auto-generated"
268 # bang CMD... will execute the command with well-defined failure mode;
269 # set bang_action to string of the failed action ('clone', 'update', ...);
270 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
271 # not spam the owner; re-define the bang_trap() function to do custom
272 # cleanup before bailing out
274 if [ -n "$show_progress" ]; then
277 read -r errcode
<<-EOT || :
279 exec 4>&3 3>&1 1>&4 4>&-
280 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
284 if [ -z "$errcode" ]; then
289 if "$@" >>"$bang_log" 2>&1; then
296 if ! [ -e .banged
] ||
[ -e .bangagain
]; then
299 ! [ -f HEAD
-a -f config
-a -d objects
] ||
300 bangmailok
="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
302 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs
="$mail"
303 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
304 if [ -z "$bangaddrs" ]; then bangaddrs
="$cfg_admin"; else bangaddrs
="$bangaddrs,$cfg_admin"; fi
305 [ -z "$bangaddrs" ] ||
307 echo "$* failed with error code $errcode"
309 [ ! -n "$bang_once" ] ||
echo "you will not receive any more notifications until recovery"
310 echo "this status message may be disabled on the project admin page"
315 } |
mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
318 cat "$bang_log" > .banglog
323 # bang_eval CMD... will evaluate the command with well-defined failure mode;
324 # Identical to bang CMD... except the command is eval'd instead of executed.
329 # Default bang settings:
331 bang_action
="lame_programmer"
334 bang_log
="$(mktemp -t repomgr-XXXXXX)"
335 trap 'rm -f "$bang_log"' EXIT
340 # Remove banged status
342 rm -f .banged .bangagain .banglog
345 # Check to see if banged status
351 # Progress report - if show_progress is set, shows the given message.
353 [ ! -n "$show_progress" ] ||
echo "$@"
357 # Project config accessors; must be run in project directory
359 git config
"gitweb.$1"
363 git config
"gitweb.$1" "$2" && chgrp
$var_group config
&& chmod g
+w config
367 git config
"$1" "$2" && chgrp
$var_group config
&& chmod g
+w config
370 config_get_date_seconds
() {
371 _dt
="$(config_get "$1" || :)"
372 [ -n "$_dt" ] ||
return 1
373 _ds
="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date
('$_dt')")"
374 [ -n "$_ds" ] ||
return 1
378 # Tool for checking whether given number of seconds has not passed yet
380 os
="$(config_get_date_seconds "$1")" ||
return 1
382 [ $ns -lt $
(($os+$2)) ]
385 # Check if we are running with effective root permissions
387 [ "$(id -u 2>/dev/null)" = "0" ]
390 # Check to see if the single argument is a Git directory
392 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
393 # And we are slightly more picky (must be refs/.+ not refs/.*)
394 [ -d "$1/objects" -a -x "$1/objects" ] ||
return 1
395 [ -d "$1/refs" -a -x "$1/refs" ] ||
return 1
396 if [ -L "$1/HEAD" ]; then
397 _hr
="$(readlink "$1/HEAD
")"
398 case "$_hr" in "refs/"?
*) :;; *) return 1;; esac
400 [ -f "$1/HEAD" -a -r "$1/HEAD" ] ||
return 1
401 read -r _hr
<"$1/HEAD" ||
return 1
406 _hr
="${_hr##ref:*[ $tab]}"
407 case "$_hr" in "refs/"?
*) return 0;; esac
412 # List all Git repositories, with given prefix if specified, one-per-line
413 # All project names starting with _ are always excluded from the result
416 LC_ALL
=C cut
-d : -f 1,3 "$cfg_chroot"/etc
/group | LC_ALL
=C
grep "^$1"
418 LC_ALL
=C cut
-d : -f 1,3 "$cfg_chroot"/etc
/group
419 fi |
while IFS
=: read name id
; do
420 [ $id -lt 65536 ] ||
case "$name" in _
*) :;; ?
*) echo "$name"; esac
424 # Return success if the given project name has any forks
427 [ -n "$_prj" ] ||
return 1
428 [ -d "$cfg_reporoot/$_prj" ] ||
return 1
429 is_git_dir
"$cfg_reporoot/$_prj.git" ||
return 1
430 test $
(get_repo_list
"$_prj/[^/][^/]*:" | LC_ALL
=C
wc -l) -gt 0
433 # returns empty string and error for empty string otherwise one of
434 # m => normal Git mirror
435 # s => mirror from svn source
436 # d => mirror from darcs source
437 # b => mirror from bzr source
438 # h => mirror from hg source
439 # w => mirror from mediawiki source
440 # f => mirror from other fast-import source
441 # note that if the string is non-empty and none of s, d, b or h match the
442 # return will always be type m regardless of whether it's a valid Git URL
443 get_url_mirror_type
() {
448 svn
://* | svn
+http
://* | svn
+https
://* | svn
+file://* | svn
+ssh://*)
457 hg
+http
://* | hg
+https
://* | hg
+file://* | hg
+ssh://* | hg
::*)
470 # returns false for empty string
471 # returns true if the passed in url is a mirror using git fast-import
472 is_gfi_mirror_url
() {
473 [ -n "$1" ] ||
return 1
474 case "$(get_url_mirror_type "$1" 2>/dev/null || :)" in
476 # darcs, bzr, hg and mediawiki mirrors use git fast-import
477 # and so do generic "f" fast-import mirrors
481 # Don't think git-svn currently uses git fast-import
482 # And Git mirrors certainly do not
486 # assume it does not use git fast-import
490 # returns mirror url for gitweb.baseurl of git directory
491 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
492 # will fail if the directory does not have .nofetch and gitweb.baseurl
493 # comes back empty -- otherwise .nofetch directories succeed with a "" return
494 # automatically strips any leading "disabled " prefix before returning result
497 # always return empty for non-mirrors
498 [ ! -e "$_gitdir/.nofetch" ] ||
return 0
499 _url
="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
501 [ -n "$_url" ] ||
return 1
502 printf '%s\n' "$_url"
506 # returns get_url_mirror_type for gitweb.baseurl of git directory
507 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
508 # will fail if the directory does not have .nofetch and gitweb.baseurl
509 # comes back empty -- otherwise .nofetch directories succeed with a "" return
510 # automatically strips any leading "disabled " prefix before testing
512 _url
="$(get_mirror_url "$@
")" ||
return 1
513 get_url_mirror_type
"$_url"
516 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
518 _url
="$(get_mirror_url "$@
")" ||
return 1
519 is_gfi_mirror_url
"$_url"
522 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
524 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
527 # A well-known UTF-8 locale is required for some of the fast-import providers
528 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
529 # but that is not reliably UTF-8 but rather usually US-ASCII.
530 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
531 # install time and store that in $var_utf8_locale if one is found.
532 # If we cannot find one in the `locale -a` output then we just use a well-known
533 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
534 # it. We only set this temporarily when running the fast-import providers.
536 LC_ALL
="${var_utf8_locale:-en_US.UTF-8}"
540 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
543 _python
="${PYTHON:-python}"
544 rm -f hg2git-marks.old hg2git-marks.new
545 if [ -f hg2git-marks
-a -s hg2git-marks
]; then
546 LC_ALL
=C
sed 's/^:\([^ ][^ ]*\) \([^ ][^ ]*\)$/\2 \1/' <hg2git-marks |
{
547 if [ -n "$var_have_git_185" ]; then
548 git cat-file
--batch-check=':%(rest) %(objectname)'
550 LC_ALL
=C
sed 's/^\([^ ][^ ]*\) \([^ ][^ ]*\)$/:\2 \1/'
552 } | LC_ALL
=C
sed '/ missing$/d' >hg2git-marks.old
553 if [ -n "$var_have_git_171" ] && \
554 git rev-parse
--quiet --verify refs
/notes
/hg
>/dev
/null
; then
555 if [ -z "$var_have_git_185" ] || \
556 ! LC_ALL
=C
cmp -s hg2git-marks hg2git-marks.old
; then
558 GIT_AUTHOR_NAME
="$_nm"
559 GIT_COMMITTER_NAME
="$_nm"
560 GIT_AUTHOR_EMAIL
="$_nm"
561 GIT_COMMITTER_EMAIL
="$_nm"
562 export GIT_AUTHOR_NAME
563 export GIT_COMMITTER_NAME
564 export GIT_AUTHOR_EMAIL
565 export GIT_COMMITTER_EMAIL
566 git notes
--ref=refs
/notes
/hg prune
567 unset GIT_AUTHOR_NAME
568 unset GIT_COMMITTER_NAME
569 unset GIT_AUTHOR_EMAIL
570 unset GIT_COMMITTER_EMAIL
579 { read -r _err1 ||
:; read -r _err2 ||
:; } <<-EOT
581 exec 4>&3 3>&1 1>&4 4>&-
584 _af="$(git config hg.authorsfile || :)"
585 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
586 --repo "$(pwd)/repo.hg" \
587 --marks "$(pwd)/hg2git-marks.old" \
588 --mapping "$(pwd)/hg2git-mapping" \
589 --heads "$(pwd)/hg2git-heads" \
590 --status "$(pwd)/hg2git-state" \
591 -U unknown --force --flatten --hg-hash'
592 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
593 eval "$_cmd" 3>&- || _e1=$?
599 --import-marks="$(pwd)/hg2git-marks.old" \
600 --export-marks="$(pwd)/hg2git-marks.new" \
601 --export-pack-edges="$(pwd)/gfi-packs" \
602 --force 3>&- || _e2=$?
608 [ "$_err1" = 0 -a "$_err2" = 0 ] ||
return 1
609 mv -f hg2git-marks.new hg2git-marks
610 rm -f hg2git-marks.old
611 git for-each-ref
--format='%(refname) %(objectname)' refs
/heads | \
612 LC_ALL
=C
sed -e 's,^refs/heads/,:,' >hg2git-heads